## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 4;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by go2rpm 1.9.0
%bcond_without check
%bcond_without bootstrap

%if %{with bootstrap}
%global debug_package %{nil}
%endif

# https://gitlab.com/cznic/ccgo
%global goipath         modernc.org/ccgo/v3
%global forgeurl        https://gitlab.com/cznic/ccgo
Version:                3.16.15
%global tag             v%{version}

%gometa -f

%global common_description %{expand:
ccgo is a C compiler targeting Go.}

%global golicenses      LICENSE
%global godocs          AUTHORS CONTRIBUTORS README.md

Name:           %{goname}
Release:        %autorelease
Summary:        C compiler targeting Go

# The main package is BSD-3-Clause, as are the tcc-0.9.27 tests.
# The sqlite tests are public domain.
# The CompCert-3.6 tests are GPL-2.0-or-later.
# The GCC tests are GPL-3.0-or-later.
License:        BSD-3-Clause and blessing and GPL-2.0-or-later and GPL-3.0-or-later
URL:            %{gourl}
Source:         %{gosource}

%description %{common_description}

%gopkg

%prep
%goprep
%autopatch -p1
# Not free:
rm -rfv v3/lib/testdata/CompCert-3.6 v3/lib/testdata/compcert_*.golden
# Replace use of ccorpus with ccorpus2:
sed -i 's|modernc.org/ccorpus\([^2]\)|modernc.org/ccorpus2\1|' $(find . -iname '*.go' -type f)
find . ! \( -name v3 -o -name _build  -o -name LICENSE -o -name AUTHORS -o -name CONTRIBUTORS \) -maxdepth 1 -exec rm -rvf {} \;
mv v3/* .
%if %{with bootstrap}
# Pulls in circular dependency:
rm -fv main.go
%endif

%generate_buildrequires
%go_generate_buildrequires

%if %{without bootstrap}
%build
%gobuild -o %{gobuilddir}/bin/ccgo %{goipath}
%endif

%install
%gopkginstall
%if %{without bootstrap}
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
%endif

%if %{with check}
%check
for test in "TestCompCert" \
            "TestGCCExecuteIEEE" \
; do
awk -i inplace '/^func.*'"$test"'\(/ { print; print "\tt.Skip(\"disabled failing test\")"; next}1' $(grep -rl $test)
done
# https://gitlab.com/cznic/cc/-/issues/155
%gocheck -d lib
%endif

%if %{without bootstrap}
%files
%license LICENSE
%doc AUTHORS CONTRIBUTORS README.md
%{_bindir}/ccgo
%endif

%gopkgfiles

%changelog
## START: Generated by rpmautospec
* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.16.15-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sat Jan 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.16.15-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Tue Oct 03 2023 W. Michael Petullo <mike@flyn.org> - 3.16.15-2
- Avoid ccorpus package dependency, use ccorpus2 instead

* Tue Oct 03 2023 W. Michael Petullo <mike@flyn.org> - 3.16.15-1
- Initial import (fedora#)
## END: Generated by rpmautospec
